----------------------------------------------------------------------------------
-- Company: Univ Lyon, UJM-Saint-Etienne, CNRS, Laboratoire Hubert Curien UMR 5516, F-42023, SAINT-ETIENNE, France
-- Creator: Cédric Marchand 
-- 
-- Create Date:    10:59:57 11/12/2015 
-- Design Name: 
-- Module Name:    x2 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity x2 is
  port(
    nible_i : in std_logic_vector(3 downto 0);
    nible_o : out std_logic_vector(3 downto 0)
  );
end x2;

architecture Behavioral of x2 is

begin

  nible_o <= nible_i(2 downto 1) & (nible_i(0) xor nible_i(3)) & nible_i(3);

end Behavioral;

